import { Logger } from './logger';
import { AddonConfig } from './native-addons';
import { ExecutableMetadata } from './executable-metadata';
import { ProcessEnv } from './helpers';
declare type CompilationOptions = {
    nodeVersionRange: string;
    tmpdir?: string;
    sourceFile: string;
    targetFile: string;
    configureArgs?: string[];
    makeArgs?: string[];
    logger?: Logger;
    clean?: boolean;
    env?: ProcessEnv;
    namespace?: string;
    addons?: AddonConfig[];
    enableBindingsPatch?: boolean;
    executableMetadata?: ExecutableMetadata;
    preCompileHook?: (nodeSourceTree: string, options: CompilationOptions) => void | Promise<void>;
};
export declare function compileJSFileAsBinary(options: Readonly<CompilationOptions>): Promise<void>;
export {};
